package com.jdnevnik.ainterface;

import java.util.*;

public class State {
    private String _name = "";

    private Map<ICondition, Transition> _transitions = new HashMap<ICondition, Transition>();
    private IActions _actions = null;

    public State(String aName) {
        _name = aName;
    }

    public Transition getTransition(Automata aAutomata) {
        for (Iterator<ICondition> iterator = _transitions.keySet().iterator(); iterator.hasNext();) {
            ICondition condition = iterator.next();
            if (condition.valid(aAutomata)) {
                return _transitions.get(condition);
            }
        }

        return null;
    }

    public IActions getActions() {
        return _actions;
    }

    public void setActions(IActions aActions) {
        _actions = aActions;
    }

    public void processActions(Automata aAutomata) {
        if (_actions != null) {
            _actions.process(aAutomata);
        }
    }

    public void addTransition(ICondition aCondition, Transition aTransition) {
        _transitions.put(aCondition, aTransition);
    }

    public String toString() {
        return _name;
    }
}
