package com.jdnevnik.ainterface;

public class Transition {
    private String _name = "";

    private State _targetState = null;
    private IActions _actions = null;

    public Transition() {
    }

    public Transition(String aName) {
        _name = aName;
    }

    public IActions getActions() {
        return _actions;
    }

    public void setActions(IActions aActions) {
        _actions = aActions;
    }

    public State getTargetState() {
        return _targetState;
    }

    public void setTargetState(State aTargetState) {
        _targetState = aTargetState;
    }

    public void activate(Automata aAutomata) {
        if (_actions != null) {
            _actions.process(aAutomata);
        }
        aAutomata.setCurrentState(_targetState);
    }

    public String toString() {
        return _name;
    }
}
