package com.jdnevnik.ainterface.listeners;

import com.jdnevnik.ainterface.*;
import com.jdnevnik.ainterface.Event;

import java.awt.event.*;
import java.awt.*;

public class AutoFocusListener extends Listener implements FocusListener {
    private boolean _actOnGained = false;
    private boolean _actOnLost = false;

    public AutoFocusListener(Automata aAutomata, State aStartState) {
        super(aAutomata, aStartState);
    }

    public void addListenerToComponent(Component aComponent, String aListenerType) {
        if (aListenerType.indexOf("gained") != -1) {
            _actOnGained = true;
        }

        if (aListenerType.indexOf("lost") != -1) {
            _actOnLost = true;
        }

        aComponent.addFocusListener(this);
    }

    public void focusGained(FocusEvent aEvent) {
        if (_actOnGained) {
            getAutomata().processEvent(new Event(getStartState(), aEvent));
        }
    }

    public void focusLost(FocusEvent aEvent) {
        if (_actOnLost) {
            getAutomata().processEvent(new Event(getStartState(), aEvent));
        }
    }
}
