package com.jdnevnik.ainterface.listeners;

import com.jdnevnik.ainterface.*;
import com.jdnevnik.ainterface.Event;

import java.awt.event.*;
import java.awt.*;

public class AutoKeyListener extends Listener implements KeyListener {
    private boolean _actOnPressed = false;
    private boolean _actOnReleased = false;
    private boolean _actOnTyped = false;

    public AutoKeyListener(Automata aAutomata, State aStartState) {
        super(aAutomata, aStartState);
    }

    public void addListenerToComponent(Component aComponent, String aListenerType) {
        if (aListenerType.indexOf("pressed") != -1) {
            _actOnPressed = true;
        }

        if (aListenerType.indexOf("released") != -1) {
            _actOnReleased = true;
        }

        if (aListenerType.indexOf("typed") != -1) {
            _actOnTyped = true;
        }

        aComponent.addKeyListener(this);
    }

    public void keyPressed(KeyEvent aEvent) {
        if (_actOnPressed) {
            getAutomata().processEvent(new Event(getStartState(), aEvent));
        }
    }

    public void keyReleased(KeyEvent aEvent) {
        if (_actOnReleased) {
            getAutomata().processEvent(new Event(getStartState(), aEvent));
        }
    }

    public void keyTyped(KeyEvent aEvent) {
        if (_actOnTyped) {
            getAutomata().processEvent(new Event(getStartState(), aEvent));
        }
    }
}
